<?php

class PrivateMessagePage extends Page {
	function requireDefaultRecords() {
		if(!DataObject::get("PrivateMessagePage")) {
			$page = new PrivateMessagePage();
			$page->Title = "Private Messages";
			$page->write();
			$page->doPublish();
		}
	}	
}

class PrivateMessagePage_Controller extends Page_Controller {
	function init() {
		if(!Member::currentUserID()) Security::permissionFailure();
		parent::init();
	}
	//returns all messages submitted to the logged in user.
	function MyMessages() {

	//what folder? nothing =inbox rest will be specified
		if(isset($this->urlParams['Action'])){
		$pmbox = $this->urlParams['Action'];
		}
		else{
		$pmbox = "Inbox";
		} 
		switch($pmbox){
		case 'inbox':
			return DataObject::get("PrivateMessage", "ToMailFolder='Inbox' AND ToDeleted=0 AND ToID = " . Member::currentUserID(), " Created DESC");
			break;
		case 'sentbox':
			return DataObject::get("PrivateMessage", "FromMailFolder='Sent' AND FromDeleted=0 AND FromID = " . Member::currentUserID(), "Created DESC");
			break;
		case 'readbox':
			return DataObject::get("PrivateMessage", "ToDeleted=0 AND ToMailFolder='Read' AND ToID = " . Member::currentUserID(), "Created DESC");
			break;
		default:
		return DataObject::get("PrivateMessage", "ToMailFolder='Inbox' AND ToDeleted=0 AND ToID = " . Member::currentUserID(), "Created DESC");
		//echo "<pre>";
		//print_r($this->urlParams);
		//echo "</pre>";

		}
		//return DataObject::get("PrivateMessage", "ToID = " . Member::currentUserID(), "Created DESC");
	}

			function getpmnos(){
			$me = Member::currentUser();
			if($me){	
			$pm = DataObject::get("PrivateMessage", "", "Created DESC ", "WHERE ToID = $me->ID AND ToDeleted=0");
			if($pm){
			$this->total = 0;
			$this->inbox = 0;
			$this->read = 0;
			foreach ($pm as $k=>$v){
			if($v->ToMailFolder == "Inbox"){
			$this->inbox = $this->inbox +1;
			}
			if($v->ToMailFolder == "Read"){
			$this->read = $this->read +1;
			}
				$this->total = $this->total +1;

			}
			//checking of sent box items
			$pm2 = DataObject::get("PrivateMessage", "", "Created DESC ", "WHERE FromID = $me->ID AND FromDeleted=0");
			if($pm2){
				$this->sent = 0;
			foreach($pm2 as $k=>$v){
				if($v->FromMailFolder == "Sent"){
				$this->sent = $this->sent +1;
				}
			$this->total = $this->total +1;
			}
			}
				return $this;
			}
			else{
				return null;
			}
		}

	}
	function PostMessageForm() {
	/* dont need to do this maybe on a large site its not that good?
        //Nicknames of all members is passed into an array
		$members = DataObject::get("Member", "", "Nickname");
		$allMembers = array();
		foreach($members as $member) {
			$allMembers[$member->ID] = "$member->Nickname";
		}
	*/
		$me = Member::currentUser();
		return new Form($this, "PostMessageForm", new FieldSet(
			new ReadonlyField("From", _t('PrivateMessagePage.FROM', 'From'), "$me->Nickname"),
			//changed to nick cause were going to allow sending to multiple members at once
			new TextField("ToNick", _t('PrivateMessagePage.CHOOSERECEIVER', 'Choose receiver')),
			new TextField("Subject", _t('PrivateMessagePage.SUBJECT', 'Subject')),
			new TextareaField("Body", _t('PrivateMessagePage.TEXT', 'Text'))
            
            ),
            new FieldSet(
                new FormAction("doPostMessage", _t('PrivateMessagePage.SUBMIT', 'submit'))
            ),
            //Required fields are named inside the array. Without subject messages can´t be red.
            new RequiredFields(array('ToNick','Subject', 'Body'))
        );
	}
    //A form that is appended when a single message is red.
    function ReplyMessageForm() {
		$me = Member::currentUser();
        //The Parameters from the sent message are loaded into $message
$message = DataObject::get_by_id("PrivateMessage", $this->urlParams['ID']);
		//get the members nick!!
		$FromNick = DataObject::get_one("Member", "ID='$message->FromID'");

        
		return new Form($this, "PostMessageForm", new FieldSet(
			new TextField("ToNick", _t('PrivateMessagePage.RECEIVER', 'receiver'), "$FromNick->Nickname"),
			new TextField("Subject", _t('PrivateMessagePage.SUBJECT', 'Subject'), "Re: $message->Subject"),
			new TextareaField("Body", "Text")
            ),
            new FieldSet(
                new FormAction("doPostMessage", _t('PrivateMessagePage.SUBMIT', 'submit'))
            ),
            //Required fields are named inside the array. Without subject messages couldn´t be red.
            new RequiredFields(array('Subject', 'Body'))
        );
	}
	//Save the input to the database
	function doPostMessage($data, $form) {
	$Rec = explode("," ,$data['ToNick']);
	//print_r($data);
	//print_r($Rec);
	foreach($Rec as $k=>$v){

		$ToID = DataObject::get_one("Member","ID", "Nickname='$v'");	
		if($ToID){
		$message = new PrivateMessage();
		$form->saveInto($message);
		$message->ToID = $ToID->ID;
		$message->ToMailFolder = "Inbox";
		$message->FromMailFolder = "Sent";
		//echo "<pre>";
		//print_r($ToID->ID);
		//echo "</pre>";
		$message->FromID = Member::currentUserID();
		$message->write();	
		}else{
				echo "not found";
				}

	}
		
		Director::redirect($this->Link());
	}
	//read the content of a single message. The ID of the message is passed via URL.
	function message() {
		$message = DataObject::get_by_id("PrivateMessage", $this->urlParams['ID']);
        //The message is only passed if the reader ist the receiver. Otherwise any message could be read by altering the id.
		if($message->ToID == Member::currentUserID()) {
            //message gets marked as red
            $message->red = true;
		$message->ToMailFolder = "Read";
            $message->write();
			return array(
				'CurrentMessage' => $message			
			);
		} else {
			return array();
		}
	}
    //Deleting a single message
    function delete() {
        $message = DataObject::get_by_id("PrivateMessage", $this->urlParams['ID']);
        if($message){
            $message->delete();
            Director::redirect($this->Link());
        }
    }
	

}